/* PISO-725 Linux Static Libary.

   Author: Golden Wang

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   Use vi or gvim to edit this file and set tabstop=4.

   v 0.0.0  12  Sep 2007 by Golden Wang
     function created for digital I/O and signal interrupt.

*/

#include "piodio.h"

extern char device_module[LINE_SIZE + 1];
extern dev_control_t *dev_ctl;

/* PISO-P8R8 output data */
WORD PISO725_Digital_Output(WORD fd, byte data)
{
  ixpio_reg_t ro;

  ro.id = IXPIO_DO;
  ro.value = data;

  if (PIODA_OutputByte(fd, &ro)) return PIODA_DIGITAL_OUTPUT_ERROR;

  return SUCCESS;
}

/* PISO-P8R8 input data */
WORD PISO725_Digital_Input(WORD fd, WORD *di_data)
{
  ixpio_reg_t ri;

  ri.id = IXPIO_DI;

  if (PIODA_InputByte(fd, &ri)) return PIODA_DIGITAL_INPUT_ERROR;

  *di_data = ri.value;

  return SUCCESS;
}

WORD PISO725_Int_Source_Init(WORD fd, WORD signal, WORD int_source)
{
  ixpio_reg_t reg;
  struct sigaction act_old;
  WORD rs;

  /* configure board interrupt */
  reg.id = IXPIO_IMCR;
  reg.value = int_source;

  if (PIODA_OutputByte(fd, &reg))
  {
    sigaction(signal, &act_old, NULL);
    return PIODA_CONFIGURE_INTERRUPT_ERROR;
  }
}
